package visualization2;

import java.util.Collections;
import java.util.List;

/**
 * 末端のデータ項目に対応するノードです。
 */

public class Item implements Node {
    private String name;
    private MultiVector vector;

    /**
     * ノードを作成します。
     * @param name ノード名
     * @param vector ベクトル
     */
    public Item(String name, MultiVector vector) {
        this.name = name;
        this.vector = vector;
    }

    /**
     * ノード名を取得します。
     * @return ノード名
     */
    public String getName() {
        return name;
    }

    /**
     * ベクトルを取得します。
     * @return ベクトル
     */
    public MultiVector getVector() {
        return vector;
    }

    public List<MultiVector> getVectors() {
        // ベクトル自身をリスト化して返す
        return Collections.singletonList(vector);
    }
}
